select
  an.cdanimal, an.numero as numero_matriz
  , an.dtbaixa
  , (select count(*) from lactacao re where re.cdanimal = an.cdanimal) as num_ord_lact_avaliada
  , ultpar.data as data_ultimo_parto
  , ((case when lac.dtfim is null then current_date else null end) - lac.dtinicio) as del_matrizes_em_lactacao
  , ((case when lac.dtfim is not null then lac.dtfim else null end) - lac.dtinicio) as duracao_matrizes_secas
  , (case when (catrep.cdcategoria = 3) then (diagp.dtpartoprovavel) else null end) as data_parto_previsto
  , (case when (catrep.cdcategoria = 3) then
            (diagp.dtpartoprovavel - cast((select valor from configuracao where upper(nome) = 'PERIODODESCANSO') as integer))
            else null end) as data_secagem_prevista
  , ccs.dtanaliseleite as data_ultima_ccs
  , ccs.ccs as ultima_ccs
  , ccs2.dtanaliseleite as data_penultima_ccs
  , ccs2.ccs as penultima_ccs
  , ccs3.dtanaliseleite as data_antepenultima_ccs
  , ccs3.ccs as antepenultima_ccs
  , le.dtleite as dt_ultimo_leite
  , le.pesototal as ultimo_leite
  , (case when (((select count(*) from mamite re where re.cdanimal = lac.cdanimal and (re.data between lac.dtinicio and current_date) and (re.ad in (0,1,2)))) > 0)
            then ((select count(*) from mamite re where re.cdanimal = lac.cdanimal and (re.data between lac.dtinicio and current_date) and (re.ad in (0,1,2)))) else null end) as Mast_clinica_AD_dias_com_grumos
  , (case when ((select count(*) from mamite re where re.cdanimal = lac.cdanimal and (re.data between lac.dtinicio and current_date) and (re.ad in (0,1,2))
                        and not exists (select * from mamite re2 where re2.cdanimal = re.cdanimal and (re2.data between (re.data - 14) and (re.data - 1)) and (re2.ad in (0,1,2)))) > 0)
            then (select count(*) from mamite re where re.cdanimal = lac.cdanimal and (re.data between lac.dtinicio and current_date) and (re.ad in (0,1,2))
                        and not exists (select * from mamite re2 where re2.cdanimal = re.cdanimal and (re2.data between (re.data - 14) and (re.data - 1)) and (re2.ad in (0,1,2))))
            else null end) as Mast_clinica_AD_caso_14_dias_dif
  , (case when ((select count(*) from escoreteto ead where ead.cdanimal = lac.cdanimal and (ead.data between lac.dtinicio and current_date) and ead.ad = 0) > 0)
            then (1)
            else null end) as Lan_escore_teto_perdido_AD
  , (case when (((select count(*) from mamite re where re.cdanimal = lac.cdanimal and (re.data between lac.dtinicio and current_date) and (re.ae in (0,1,2)))) > 0)
            then ((select count(*) from mamite re where re.cdanimal = lac.cdanimal and (re.data between lac.dtinicio and current_date) and (re.ae in (0,1,2)))) else null end) as Mast_clinica_AE_dias_com_grumos
  , (case when ((select count(*) from mamite re where re.cdanimal = lac.cdanimal and (re.data between lac.dtinicio and current_date) and (re.ae in (0,1,2))
                        and not exists (select * from mamite re2 where re2.cdanimal = re.cdanimal and (re2.data between (re.data - 14) and (re.data - 1)) and (re2.ae in (0,1,2)))) > 0)
            then (select count(*) from mamite re where re.cdanimal = lac.cdanimal and (re.data between lac.dtinicio and current_date) and (re.ae in (0,1,2))
                        and not exists (select * from mamite re2 where re2.cdanimal = re.cdanimal and (re2.data between (re.data - 14) and (re.data - 1)) and (re2.ae in (0,1,2))))
            else null end) as Mast_clinica_AE_caso_14_dias_dif
  , (case when ((select count(*) from escoreteto ead where ead.cdanimal = lac.cdanimal and (ead.data between lac.dtinicio and current_date) and ead.ae = 0) > 0)
            then (1)
            else null end) as Lan_escore_teto_perdido_AE
  , (case when (((select count(*) from mamite re where re.cdanimal = lac.cdanimal and (re.data between lac.dtinicio and current_date) and (re.pd in (0,1,2)))) > 0)
            then ((select count(*) from mamite re where re.cdanimal = lac.cdanimal and (re.data between lac.dtinicio and current_date) and (re.pd in (0,1,2)))) else null end) as Mast_clinica_PD_dias_com_grumos
  , (case when ((select count(*) from mamite re where re.cdanimal = lac.cdanimal and (re.data between lac.dtinicio and current_date) and (re.pd in (0,1,2))
                        and not exists (select * from mamite re2 where re2.cdanimal = re.cdanimal and (re2.data between (re.data - 14) and (re.data - 1)) and (re2.pd in (0,1,2)))) > 0)
            then (select count(*) from mamite re where re.cdanimal = lac.cdanimal and (re.data between lac.dtinicio and current_date) and (re.pd in (0,1,2))
                        and not exists (select * from mamite re2 where re2.cdanimal = re.cdanimal and (re2.data between (re.data - 14) and (re.data - 1)) and (re2.pd in (0,1,2))))
            else null end) as Mast_clinica_PD_caso_14_dias_dif
  , (case when ((select count(*) from escoreteto ead where ead.cdanimal = lac.cdanimal and (ead.data between lac.dtinicio and current_date) and ead.pd = 0) > 0)
            then (1)
            else null end) as Lan_escore_teto_perdido_PD
  , (case when (((select count(*) from mamite re where re.cdanimal = lac.cdanimal and (re.data between lac.dtinicio and current_date) and (re.pe in (0,1,2)))) > 0)
            then ((select count(*) from mamite re where re.cdanimal = lac.cdanimal and (re.data between lac.dtinicio and current_date) and (re.pe in (0,1,2)))) else null end) as Mast_clinica_PE_dias_com_grumos
  , (case when ((select count(*) from mamite re where re.cdanimal = lac.cdanimal and (re.data between lac.dtinicio and current_date) and (re.pe in (0,1,2))
                        and not exists (select * from mamite re2 where re2.cdanimal = re.cdanimal and (re2.data between (re.data - 14) and (re.data - 1)) and (re2.pe in (0,1,2)))) > 0)
            then (select count(*) from mamite re where re.cdanimal = lac.cdanimal and (re.data between lac.dtinicio and current_date) and (re.pe in (0,1,2))
                        and not exists (select * from mamite re2 where re2.cdanimal = re.cdanimal and (re2.data between (re.data - 14) and (re.data - 1)) and (re2.pe in (0,1,2))))
            else null end) as Mast_clinica_PE_caso_14_dias_dif
  , (case when ((select count(*) from escoreteto ead where ead.cdanimal = lac.cdanimal and (ead.data between lac.dtinicio and current_date) and ead.pe = 0) > 0)
            then (1)
            else null end) as Lan_escore_teto_perdido_PE
  , cult1.data as dt_primeiro_cultivo
  , (case when (cult1.cdmicroorganismo1 is not null)
            then (select nome from microorganismo where cdmicroorganismo = cult1.cdmicroorganismo1) else null end) as Resultado_1_primeiro_cultivo
  , (case when (cult1.cdmicroorganismo2 is not null)
            then (select nome from microorganismo where cdmicroorganismo = cult1.cdmicroorganismo2) else null end) as Resultado_2_primeiro_cultivo
  , cult2.data as dt_segundo_cultivo
  , (case when (cult2.cdmicroorganismo1 is not null)
            then (select nome from microorganismo where cdmicroorganismo = cult2.cdmicroorganismo1) else null end) as Resultado_1_segundo_cultivo
  , (case when (cult2.cdmicroorganismo2 is not null)
            then (select nome from microorganismo where cdmicroorganismo = cult2.cdmicroorganismo2) else null end) as Resultado_2_segundo_cultivo
  , cult3.data as dt_terceiro_cultivo
  , (case when (cult3.cdmicroorganismo1 is not null)
            then (select nome from microorganismo where cdmicroorganismo = cult3.cdmicroorganismo1) else null end) as Resultado_1_terceiro_cultivo
  , (case when (cult3.cdmicroorganismo2 is not null)
            then (select nome from microorganismo where cdmicroorganismo = cult3.cdmicroorganismo2) else null end) as Resultado_2_terceiro_cultivo
from
  animal an
  join lactacao lac on lac.cdlactacao =
      (select first 1 re.cdlactacao from lactacao re where re.cdanimal = an.cdanimal order by re.dtinicio desc)
  join reproducao ultpar on ultpar.cdreproducao =
    (select first 1 re.cdreproducao from reproducao re where re.cdanimal = an.cdanimal and re.cdtiporeproducao = 7 order by re.data desc)
  join categoria catrep on catrep.cdcategoria =
    (select sp.creprodutiva from sp_categoriaanimal(current_date, 'cdanimal = ' || an.cdanimal) sp)
  left join reproducao diagp on diagp.cdreproducao =
    (select first 1 re.cdreproducao from reproducao re where re.cdanimal = an.cdanimal and re.diagnostico = 'P' order by re.data desc)
  left join analiseleite ccs on ccs.cdanaliseleite =
    (select first 1 re.cdanaliseleite from analiseleite re where re.cdanimal = lac.cdanimal and re.dtanaliseleite >= lac.dtinicio and re.ccs > 0 order by re.dtanaliseleite desc)
  left join analiseleite ccs2 on ccs2.cdanaliseleite =
    (select first 1 re.cdanaliseleite from analiseleite re where re.cdanimal = lac.cdanimal and re.dtanaliseleite >= lac.dtinicio and re.ccs > 0 and re.dtanaliseleite < ccs.dtanaliseleite order by re.dtanaliseleite desc)
  left join analiseleite ccs3 on ccs3.cdanaliseleite =
    (select first 1 re.cdanaliseleite from analiseleite re where re.cdanimal = lac.cdanimal and re.dtanaliseleite >= lac.dtinicio and re.ccs > 0 and re.dtanaliseleite < ccs2.dtanaliseleite order by re.dtanaliseleite desc)
  left join leite le on le.cdleite =
    (select first 1 re.cdleite from leite re where re.cdlactacao = lac.cdlactacao order by re.dtleite desc)
  left join mamite cult1 on cult1.cdmamite =
    (select first 1 re.cdmamite from mamite re where re.cdanimal = lac.cdanimal and re.data >= lac.dtinicio and ((re.cdmicroorganismo1 is not null) or (re.cdmicroorganismo2 is not null)) order by re.data asc)
  left join mamite cult2 on cult2.cdmamite =
    (select first 1 re.cdmamite from mamite re where re.cdanimal = lac.cdanimal and re.data >= lac.dtinicio and ((re.cdmicroorganismo1 is not null) or (re.cdmicroorganismo2 is not null))
            and re.data > cult1.data order by re.data asc)
  left join mamite cult3 on cult3.cdmamite =
    (select first 1 re.cdmamite from mamite re where re.cdanimal = lac.cdanimal and re.data >= lac.dtinicio and ((re.cdmicroorganismo1 is not null) or (re.cdmicroorganismo2 is not null))
            and re.data > cult2.data order by re.data asc)
order by an.numordenado
